﻿Type=Class
Version=5.5
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module
#Event:
private Sub Class_Globals
	Private accfolder,accfile As String
	Private factory , twitter4j , requestToken , accesstoken,statusupdate,sfile As JavaObject
	Private caller_obj As Object
	Private key,secret,acctoken,acctokensec,tEvent As String
	
End Sub
'Initializes the object. You can add parameters to this method if needed.
'success_init: the sub called after getting the accesstoken
Public Sub Initialize(callerobject As Object,consumerkey As String,consumersecret As String,accesstokendir As String,accesstokenfile As String,success_ini As String)
	caller_obj=callerobject
	'success_init=
	tEvent=success_ini
	key=consumerkey
	secret=consumersecret
	Dim thready As Thread
	thready.Initialise("")
	thready.Start(Me,"Real_Initialize",Array(callerobject,consumerkey,consumersecret,accesstokendir,accesstokenfile,success_ini))

End Sub
private Sub Real_Initialize(callerobject As Object,consumerkey As String,consumersecret As String,accesstokendir As String,accesstokenfile As String,success_ini As String)
	
	factory.InitializeStatic("twitter4j.TwitterFactory")
	twitter4j=factory.RunMethod("getSingleton",Null)
	

	accfolder=accesstokendir
	accfile=accesstokenfile
	If File.Exists(accesstokendir,accesstokenfile) Then
		LoadAccessToken		
	Else

		Dim url As String
		twitter4j.RunMethod("setOAuthConsumer",Array(consumerkey,consumersecret))
		requestToken=twitter4j.RunMethod("getOAuthRequestToken",Null)

		url=requestToken.RunMethod("getAuthenticationURL",Null)
		Log(url)
'		Log(twitter4j.RunMethod("getOAuthAccessToken",Null))
		If url.Length>0 Then
			If SubExists(caller_obj, tEvent&"_OpenBrowser") Then
				CallSubDelayed2(caller_obj,tEvent&"_OpenBrowser",url)
				Return url
			End If
		
		Else
			'Error Getting Authorization URL
		End If




	End If
	
End Sub
Public Sub mediatweet(mdir As String,mfile As String,TweetString As String)
	Dim MediaThread As Thread
	MediaThread.Initialise("mediaz")
	MediaThread.Start(Me,"tweetmedia",Array(mdir,mfile,TweetString))
	
End Sub
Private Sub mediaz_Ended(fail As Boolean, error As String) 
	If SubExists(caller_obj,tEvent&"_MediaSent") Then
		CallSubDelayed3(caller_obj,tEvent&"_MediaSent",fail,error)
	End If
	
End Sub
Sub GetAccessToken(verifier As String)
	Dim accessthread As Thread
	accessthread.Initialise("access")
	accessthread.Start(Me,"real_access",Array(verifier))
'	Log()
	
End Sub

Private Sub real_access(veri As String)
	accesstoken =twitter4j.RunMethod("getOAuthAccessToken",Array(requestToken,veri))
	acctoken=accesstoken.RunMethod("getToken",Null)
	acctokensec=accesstoken.RunMethod("getTokenSecret",Null)
End Sub

Private Sub access_Ended(fail As Boolean, error As String) 
	File.WriteList(accfolder,accfile,Array(acctoken,acctokensec))
	If SubExists(caller_obj,tEvent&"_AccessToken") Then
		CallSubDelayed3(caller_obj,tEvent&"_AccessToken",fail,error)
	End If
	
End Sub

Private Sub tweetmedia(mdir As String,mfile As String,TweetString As String)
	sfile.InitializeNewInstance("java.io.File",Array(mdir,mfile))

	statusupdate.InitializeNewInstance("twitter4j.StatusUpdate",Array(TweetString))
	statusupdate.RunMethod("setMedia",Array(sfile))
	twitter4j.RunMethod("updateStatus",Array(statusupdate))
	
End Sub
Private Sub LoadAccessToken
	Dim acclist As List
	acclist.Initialize
	acclist=File.ReadList(accfolder,accfile)
	twitter4j.RunMethod("setOAuthConsumer",Array(key,secret))
	
	accesstoken.InitializeNewInstance("twitter4j.auth.AccessToken",Array(acclist.Get(0),acclist.Get(1)))
	twitter4j.RunMethod("setOAuthAccessToken",Array(accesstoken))
End Sub
Public Sub TokenExists As Boolean
	If File.Exists(accfolder,accfile) Then
		Return True
	Else
		Return False
	End If
End Sub
Public Sub SetAuth(code As String)
	Dim auththread As Thread
	auththread.Initialise("thre")
	auththread.Start(Me,"SetAuth_Thread",Array(code))
End Sub

Private Sub SetAuth_Thread(code As String)
	accesstoken = twitter4j.RunMethod("getOAuthAccessToken",Array(requestToken, code))
	File.WriteList(accfolder,accfile,Array(accesstoken.RunMethod("getToken",Null),accesstoken.RunMethod("getTokenSecret",Null)))

	
End Sub


Public Sub Tweet(TweetText As String)
	Dim TweeThread As Thread
	TweeThread.Initialise("")
	TweeThread.Start(Me,"Tweet_Thread",Array(TweetText))
End Sub
Private Sub Tweet_Thread(mweet As String)
	twitter4j.RunMethod("updateStatus",Array(mweet))

End Sub


